LightOJ - 1017


Brush (III)



Submit Status




Description




Samir returned home from the contest and got angry after seeing his room dusty. Who likes to see a dusty room after a brain storming programming contest? After checking a bit he found a brush in his room which has width w. Dusts are defined as 2D points. And since they are scattered everywhere, Samir is a bit confused what to do. He asked Samee and found his idea. So, he attached a rope with the brush such that it can be moved horizontally (in X axis) with the help of the rope but in straight line. He places it anywhere and moves it. For example, the y co-ordinate of the bottom part of the brush is 2 and its width is 3, so the y coordinate of the upper side of the brush will be 5. And if the brush is moved, all dusts whose y co-ordinates are between 2 and 5 (inclusive) will be cleaned. After cleaning all the dusts in that part, Samir places the brush in another place and uses the same procedure. He defined a move as placing the brush in a place and cleaning all the dusts in the horizontal zone of the brush.

You can assume that the rope is sufficiently large. Since Samir is too lazy, he doesn't want to clean all the room. Instead of doing it he thought that he would use at most k moves. Now he wants to find the maximum number of dust units he can clean using at most k moves. Please help him.





Input



Input starts with an integer T (≤ 100), denoting the number of test cases.

Each case starts with a blank line. The next line contains three integers N (1 ≤ N ≤ 100), w (1 ≤ w ≤ 10000) and k (1 ≤ k ≤ 100)N means that there are N dust points. Each of the nextN lines contains two integers: xi yi denoting the coordinates of the dusts. You can assume that (-109 ≤ xi, yi ≤ 109) and all points are distinct.





Output



For each case print the case number and the maximum number of dusts Samir can clean using at most k moves.





Sample Input



2

 

3 2 1

0 0

20 2

30 2

 

3 1 1

0 0

20 2

30 2





Sample Output



Case 1: 3

Case 2: 2

//题意:输入n,w,m,n表示点的个数。

有一把刷子,每次可以横向的刷掉宽度为w的灰尘,现在最多可以刷m次。最多可以刷掉多少灰尘

思路:dp[i][j]表示刷到第i个灰尘用了j次的最多刷灰尘数,首先肯定对灰尘以y坐标排序。对于每个i的,我们可以枚举一个1~i的k,然后k~i的高度差小于等于w的话,k~i就可以一次刷完,这个时候我们就可以得到转移方程:dp[i][k] = max(dp[i][k], dp[j-1][k-1] + cnt),这个cnt就是之间的灰尘数量。

#include<stdio.h>
#include<string.h>
#include<math.h>
#include<map>
#include<stack>
#include<queue>
#include<vector>
#include<algorithm>
#define INF 0x3f3f3f
#define ull unsigned long long
#define ll long long
#define IN __int64
#define N 110
#define M 100000007
using namespace std;
int dp[N][N];
struct zz
{
	int x;
	int y;
}p[N];
bool cmp(zz a,zz b)
{
	return a.y<b.y;
}
int main()
{
	int t,T=1,n,w,m,i,j,k;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d%d",&n,&w,&m);
		for(i=1;i<=n;i++)
			scanf("%d%d",&p[i].x,&p[i].y);
		sort(p+1,p+n+1,cmp);
		memset(dp,0,sizeof(dp));
		for(i=1;i<=n;i++)
		{
			for(k=1;k<=m;k++)
			{
				dp[i][k]+=dp[i-1][k];
				int cnt=0;
				for(j=i;j>=1;j--)
				{
					if(p[i].y-p[j].y>w)
						break;
					else
					{
						cnt++;
						dp[i][k]=max(dp[i][k],dp[j-1][k-1]+cnt);
					}
				}
			}
		}
		int ans=0;
		for(i=1;i<=m;i++)
			ans=max(dp[n][i],ans);
		printf("Case %d: %d\n",T++,ans);
	}
	return 0;
}

 



Time Limit: 2000MS

Memory Limit: 32768KB

64bit IO Format: %lld & %llu